<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>m17n ライブラリ: 構造体 MInputDriver</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- 作成： Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'検索');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>メインページ</span></a></li>
      <li><a href="pages.html"><span>関連ページ</span></a></li>
      <li><a href="modules.html"><span>モジュール</span></a></li>
      <li class="current"><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="files.html"><span>ファイル</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="検索" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="classes.html"><span>データ構造索引</span></a></li>
      <li><a href="functions.html"><span>データフィールド</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>構造体 MInputDriver<br/>
<small>
[<a class="el" href="group__m17nInputMethod.html">入力メソッド (基本部分)</a>]</small>
</h1><!-- doxytag: class="MInputDriver" -->
<p>入力ドライバ用構造体.  
<a href="#_details">[詳細]</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>変数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputDriver.html#a6de5d7d05acec89bf7e41b2f234082f7">open_im</a> )(<a class="el" href="structMInputMethod.html">MInputMethod</a> *im)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">入力メソッドをオープンする.  <a href="#a6de5d7d05acec89bf7e41b2f234082f7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputDriver.html#a6e9c0255e16e7a1039f0078c44a15fbb">close_im</a> )(<a class="el" href="structMInputMethod.html">MInputMethod</a> *im)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">入力メソッドをクローズする.  <a href="#a6e9c0255e16e7a1039f0078c44a15fbb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputDriver.html#ab5a159c0f0b8920b088db43c7a4f0064">create_ic</a> )(<a class="el" href="structMInputContext.html">MInputContext</a> *ic)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">入力コンテクストを生成する.  <a href="#ab5a159c0f0b8920b088db43c7a4f0064"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputDriver.html#ace8401115ecab3c6a859d49665e48bd4">destroy_ic</a> )(<a class="el" href="structMInputContext.html">MInputContext</a> *ic)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">入力コンテクストを破壊する.  <a href="#ace8401115ecab3c6a859d49665e48bd4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputDriver.html#a09e43f1c01e441351b7c0c5e16a129dc">filter</a> )(<a class="el" href="structMInputContext.html">MInputContext</a> *ic, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *arg)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">入力キーをフィルタする.  <a href="#a09e43f1c01e441351b7c0c5e16a129dc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputDriver.html#a8b206e6ce988f1aeafac41efadf493af">lookup</a> )(<a class="el" href="structMInputContext.html">MInputContext</a> *ic, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *arg, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">入力コンテクストで生成されるテキストの獲得.  <a href="#a8b206e6ce988f1aeafac41efadf493af"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputDriver.html#a159fe7401cd0913dc8c480a18efeff64">callback_list</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">コールバック関数のリスト.  <a href="#a159fe7401cd0913dc8c480a18efeff64"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>説明</h2>
<p>入力ドライバ用構造体. </p>
<p><code><a class="el" href="structMInputDriver.html" title="入力ドライバ用構造体.">MInputDriver</a></code> は、入力メソッドを取り扱う関数を含む入力メソッドドライバの構造体の型である。 </p>
<hr/><h2>構造体</h2>
<a class="anchor" id="a6de5d7d05acec89bf7e41b2f234082f7"></a><!-- doxytag: member="MInputDriver::open_im" ref="a6de5d7d05acec89bf7e41b2f234082f7" args=")(MInputMethod *im)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMInputDriver.html#a6de5d7d05acec89bf7e41b2f234082f7">MInputDriver::open_im</a>)(<a class="el" href="structMInputMethod.html">MInputMethod</a> *im)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>入力メソッドをオープンする. </p>
<p>この関数は、入力メソッド <b>im</b> をオープンする。<b>im</b> の &lt;info&gt; 以外の全メンバーがセットされた後で、関数 <a class="el" href="group__m17nInputMethod.html#ga34d3e527bfd705d2b7f2b749199c1e11" title="入力メソッドをオープンする.">minput_open_im()</a> から呼ばれる。<b>im</b> をオープンできれば 0 を、できなければ -1を返す。 この関数は <b>im-&gt;info</b> を設定して、他のドライバ関数から参照される情報を保持することができる。 </p>

</div>
</div>
<a class="anchor" id="a6e9c0255e16e7a1039f0078c44a15fbb"></a><!-- doxytag: member="MInputDriver::close_im" ref="a6e9c0255e16e7a1039f0078c44a15fbb" args=")(MInputMethod *im)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void(* <a class="el" href="structMInputDriver.html#a6e9c0255e16e7a1039f0078c44a15fbb">MInputDriver::close_im</a>)(<a class="el" href="structMInputMethod.html">MInputMethod</a> *im)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>入力メソッドをクローズする. </p>
<p>この関数は、入力メソッド <b>im</b> をクローズする。関数 <a class="el" href="group__m17nInputMethod.html#ga373b415d157c2507f4ca4a864836e905" title="入力メソッドをクローズする.">minput_close_im()</a> から呼ばれる。 入力メソッドのクローズがすべて終了した時点で、この関数は<b>im-&gt;info</b> に割り当てられているメモリを(あれば)すべて開放する。 ただし、<b>im</b> の他のメンバに影響を与えてはならない。 </p>

</div>
</div>
<a class="anchor" id="ab5a159c0f0b8920b088db43c7a4f0064"></a><!-- doxytag: member="MInputDriver::create_ic" ref="ab5a159c0f0b8920b088db43c7a4f0064" args=")(MInputContext *ic)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMInputDriver.html#ab5a159c0f0b8920b088db43c7a4f0064">MInputDriver::create_ic</a>)(<a class="el" href="structMInputContext.html">MInputContext</a> *ic)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>入力コンテクストを生成する. </p>
<p>この関数は入力コンテクスト <b>ic</b> を生成する。 <b>ic</b> の &lt;info&gt; 以外の全メンバーがセットされた後で、関数 <a class="el" href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859" title="入力コンテクストを生成する.">minput_create_ic()</a> から呼ばれる。 <b>ic</b> を生成できれば 0 を、できなければ -1 を返す。 この関数は <b>ic-&gt;info</b> を設定して、他のドライバ関数から参照される情報を保持することができる。 </p>

</div>
</div>
<a class="anchor" id="ace8401115ecab3c6a859d49665e48bd4"></a><!-- doxytag: member="MInputDriver::destroy_ic" ref="ace8401115ecab3c6a859d49665e48bd4" args=")(MInputContext *ic)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void(* <a class="el" href="structMInputDriver.html#ace8401115ecab3c6a859d49665e48bd4">MInputDriver::destroy_ic</a>)(<a class="el" href="structMInputContext.html">MInputContext</a> *ic)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>入力コンテクストを破壊する. </p>
<p>関数 <a class="el" href="group__m17nInputMethod.html#ga80e4b330fb112883f2183d54b4e9c5bb" title="入力コンテクストを破壊する.">minput_destroy_ic()</a> から呼ばれ、入力コンテクスト <b>ic</b> を破壊する。入力コンテクストの破壊がすべて終了した時点で、<b>ic-&gt;info</b> に割り当てられているメモリを(あれば)すべて開放する。ただし、<b>ic</b> の他のメンバに影響を与えてはならない。 </p>

</div>
</div>
<a class="anchor" id="a09e43f1c01e441351b7c0c5e16a129dc"></a><!-- doxytag: member="MInputDriver::filter" ref="a09e43f1c01e441351b7c0c5e16a129dc" args=")(MInputContext *ic, MSymbol key, void *arg)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMInputDriver.html#a09e43f1c01e441351b7c0c5e16a129dc">MInputDriver::filter</a>)(<a class="el" href="structMInputContext.html">MInputContext</a> *ic, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *arg)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>入力キーをフィルタする. </p>
<p>関数 <a class="el" href="group__m17nInputMethod.html#ga6d9c3c97524114496fd8b7f70af92457" title="入力キーをフィルタする.">minput_filter()</a> から呼ばれ、入力キーをフィルタする。引数 <b>key</b>, <b>arg</b> は関数 <a class="el" href="group__m17nInputMethod.html#ga6d9c3c97524114496fd8b7f70af92457" title="入力キーをフィルタする.">minput_filter()</a> のものと同じ。</p>
<p>この関数は <b>key</b> を処理し、<b>ic</b> の内部状態を更新する。 <b>key</b> が入力メソッドに吸収されてテキストが生成されなかった場合には、 1 を返す。そうでなければ 0 を返す。</p>
<p>メンバ &lt;callback&gt; に必要であれば、<b>ic-&gt;status</b>, <b>ic-&gt;preedit</b>, <b>ic-&gt;cursor_pos</b>, <b>ic-&gt;ncandidates</b>, <b>ic-&gt;candidates</b>, <b>ic-&gt;produced</b> を更新できる。</p>
<p><b>arg</b> の意味は入力メソッドドライバに依存する。例は <code>minput_default_driver</code> または <code>minput_gui_driver</code> の説明を参照のこと。 </p>

</div>
</div>
<a class="anchor" id="a8b206e6ce988f1aeafac41efadf493af"></a><!-- doxytag: member="MInputDriver::lookup" ref="a8b206e6ce988f1aeafac41efadf493af" args=")(MInputContext *ic, MSymbol key, void *arg, MText *mt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMInputDriver.html#a8b206e6ce988f1aeafac41efadf493af">MInputDriver::lookup</a>)(<a class="el" href="structMInputContext.html">MInputContext</a> *ic, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *arg, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>入力コンテクストで生成されるテキストの獲得. </p>
<p>関数 <a class="el" href="group__m17nInputMethod.html#gafe533480c705b877189938a0eecb1b57" title="入力コンテクスト中のテキストを探す.">minput_lookup()</a> から呼ばれ、入力コンテクスト <b>ic</b> で生成されるテキストを検索する。入力キー <b>key</b> によって生成されるテキストがあれば、M-text <b>mt</b> に追加する。 <b>key</b> が入力メソッド <b>ic</b> によって正しく処理されれば 0 を返す。そうでなければ 1 を返す。</p>
<p><b>arg</b> の意味は入力メソッドドライバに依存する。例は <code>minput_default_driver</code> または <code>minput_gui_driver</code> の説明を参照の こと。 </p>

</div>
</div>
<a class="anchor" id="a159fe7401cd0913dc8c480a18efeff64"></a><!-- doxytag: member="MInputDriver::callback_list" ref="a159fe7401cd0913dc8c480a18efeff64" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* <a class="el" href="structMInputDriver.html#a159fe7401cd0913dc8c480a18efeff64">MInputDriver::callback_list</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>コールバック関数のリスト. </p>
<p>コールバック関数のリスト。キーは次のいずれか。 <b>Minput_preedit_start</b>, <b>Minput_preedit_draw</b>, <b>Minput_preedit_done</b>, <b>Minput_status_start</b>, <b>Minput_status_draw</b>, <b>Minput_status_done</b>, <b>Minput_candidates_start</b>, <b>Minput_candidates_draw</b>, <b>Minput_candidates_done</b>, <b>Minput_set_spot</b>, <b>Minput_toggle</b>, <b>Minput_reset</b>, <b>Minput_get_surrounding_text</b>, <b>Minput_delete_surrounding_text。</b> 値は<a class="el" href="group__m17nInputMethod.html#ga93a20c4a45f229e921bc4a3e1aa85312" title="入力メソッドコールバック関数の型宣言.">MInputCallbackFunc</a> 型の関数。 </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>全て</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>データ構造</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>ファイル</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>関数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>変数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>型定義</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>列挙型</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>列挙型の値</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>マクロ定義</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<!-- -*- coding: utf-8; -*- -->
<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-ja/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
